char *
__b2c__concat (int n, ...)
{
  long length = 0, cnew, idx;
  char *next;
  va_list ap;
  if (n == 0)
    {
      return (EmptyString);
    }
  idx = __sbuf_malloc_handle (sizeof (char));
  va_start (ap, n);
  while (n)
    {
      next = va_arg (ap, char *);
      if (next)
	{
	  cnew = __b2c__len (next);
	  __sbuf_need_realloc (idx, length + cnew + 1);
	  memmove (__b2c__sbuffer[idx] + length, next, cnew);
	  length += cnew;
	}
      n--;
    }
  va_end (ap);
  __b2c__SETLEN (__b2c__sbuffer[idx], length);
  __b2c__sbuffer[idx][length] = '\0';
  return ((char *) __b2c__sbuffer[idx]);
}

char *
ERR__b2c__string_var (int nr)
{
  switch (nr)
    {
    case 0:
      strcpy (__b2c__warn, "Success");
      break;
    case 1:
      strcpy (__b2c__warn, "Trying to access illegal memory: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 2:
      strcpy (__b2c__warn, "Error opening file: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 3:
      strcpy (__b2c__warn, "Could not open library.");
      break;
    case 4:
      strcpy (__b2c__warn, "Symbol not found in library.");
      break;
    case 5:
      strcpy (__b2c__warn, "Wrong value: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 6:
      strcpy (__b2c__warn, "Unable to claim memory.");
      break;
    case 7:
      strcpy (__b2c__warn, "Unable to delete file: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 8:
      strcpy (__b2c__warn, "Could not open directory: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 9:
      strcpy (__b2c__warn, "Unable to rename file: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 10:
      strcpy (__b2c__warn,
	      "NETWORK argument should contain colon with port number");
      break;
    case 11:
      strcpy (__b2c__warn, "Could not resolve hostname!");
      break;
    case 12:
      strcpy (__b2c__warn, "Socket error: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 13:
      strcpy (__b2c__warn, "Unable to open address: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 14:
      strcpy (__b2c__warn, "Error reading from socket: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 15:
      strcpy (__b2c__warn, "Error sending to socket: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 16:
      strcpy (__b2c__warn, "Error checking socket: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 17:
      strcpy (__b2c__warn, "Unable to bind the specified socket address: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 18:
      strcpy (__b2c__warn, "Unable to listen to socket address: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 19:
      strcpy (__b2c__warn, "Cannot accept incoming connection: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 20:
      strcpy (__b2c__warn, "Unable to remove directory: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 21:
      strcpy (__b2c__warn, "Unable to create directory: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 22:
      strcpy (__b2c__warn, "Unable to change to directory: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 23:
      strcpy (__b2c__warn,
	      "GETENVIRON argument does not exist as environment variable");
      break;
    case 24:
      strcpy (__b2c__warn, "Unable to stat file: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 25:
      strcpy (__b2c__warn, "Search contains illegal string");
      break;
    case 26:
      strcpy (__b2c__warn, "Cannot return name: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 27:
      strcpy (__b2c__warn, "Illegal regex expression");
      break;
    case 28:
      strcpy (__b2c__warn, "Unable to create bidirectional pipes: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 29:
      strcpy (__b2c__warn, "Unable to fork process: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 30:
      strcpy (__b2c__warn, "Cannot read from pipe: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 31:
      strcpy (__b2c__warn, "Gosub nesting too deep!");
      break;
    case 32:
      strcpy (__b2c__warn, "Could not open device: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 33:
      strcpy (__b2c__warn, "Error configuring serial port: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 34:
      strcpy (__b2c__warn, "Error accessing device: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 35:
      strcpy (__b2c__warn, "Error in INPUT: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 36:
      strcpy (__b2c__warn, "Illegal value in SORT dimension!");
      break;
    case 37:
      strcpy (__b2c__warn, "Illegal option for SEARCH!");
      break;
    case 38:
      strcpy (__b2c__warn, "Invalid UTF8 string!");
      break;
    case 39:
      strcpy (__b2c__warn, "Illegal EVAL expression!");
      break;
    case 40:
      strcpy (__b2c__warn, "SSL file descriptor error!");
      break;
    case 41:
      strcpy (__b2c__warn, "SSL file descriptor pool exhausted!");
      break;
    case 42:
      strcpy (__b2c__warn, "Widget not found!");
      ERROR = 42;
      break;
    case 43:
      strcpy (__b2c__warn, "Unsupported array type!");
      break;
    };
  ERROR = 0;
  return (__b2c__warn);
}

long
__b2c__instr (int l, char *k, char *first, char *tmp, int pos)
{
  char *result;
  if (first == NULL)
    {
      return (0);
    }
  if (tmp == NULL || __b2c__len (tmp) == 0)
    {
      return (0);
    }
  if (pos <= 0)
    {
      pos = 1;
    }
  result = strstr (first + pos - 1, tmp);
  if (result == NULL)
    {
      return (0);
    }
  if (__b2c__option_utf8)
    {
      return (long) __b2c__ucs2_clen (l, k, "INSTR", first,
				      result - first + 1);
    }
  return (long) (result - first + 1);
}

void *
__rbuf_realloc (void *__b2c__ptr, size_t __b2c__size)
{
  if (__b2c__rbuffer_length[__b2c__rbuffer_ptr] < __b2c__size)
    {
      __b2c__rbuffer_length[__b2c__rbuffer_ptr] = (size_t) __b2c__size *4;
      return (realloc
	      (__b2c__ptr, __b2c__rbuffer_length[__b2c__rbuffer_ptr]));
    }
  return (__b2c__ptr);
}

void
__sbuf_need_realloc (long idx, size_t size)
{
  if (__b2c__sbuffer[idx] == NULL)
    {
      __b2c__sbuffer[idx] =
	(char *) calloc (__b2c__BUFOFFSET + size * 2 + 1, sizeof (char));
      *(uint32_t *) (__b2c__sbuffer[idx] + 4) = size * 2 + 1;
      *(uint8_t *) (__b2c__sbuffer[idx] + 8) = 1;
      __b2c__SETRANGE (__b2c__sbuffer[idx]);
      __b2c__sbuffer[idx] += __b2c__BUFOFFSET;
    }
  else if (__b2c__buf (__b2c__sbuffer[idx]) <= size)
    {
      __b2c__sbuffer[idx] =
	(char *) realloc (__b2c__sbuffer[idx] - __b2c__BUFOFFSET,
			  __b2c__BUFOFFSET + size * 2 + 1);
      *(uint32_t *) (__b2c__sbuffer[idx] + 4) = size * 2 + 1;
      *(uint8_t *) (__b2c__sbuffer[idx] + 8) = 1;
      __b2c__SETRANGE (__b2c__sbuffer[idx]);
      __b2c__sbuffer[idx] += __b2c__BUFOFFSET;
    }
}

long
__sbuf_malloc_handle (size_t size)
{
  __b2c__sbuffer_ptr++;
  if (__b2c__sbuffer_ptr >= __b2c__sbuffer_size)
    __b2c__sbuffer_ptr = 0;
  __sbuf_need_realloc (__b2c__sbuffer_ptr, size);
  memset (__b2c__sbuffer[__b2c__sbuffer_ptr], 0, size);
  __b2c__SETLEN (__b2c__sbuffer[__b2c__sbuffer_ptr], 0);
  return (__b2c__sbuffer_ptr);
}

char *
__b2c__strdup (const char *s)
{
  if (s == NULL)
    {
      return (NULL);
    }
  return (strdup (s));
}

char *
__b2c__strndup (const char *s, size_t n)
{
  char *cnew;
  if (s == NULL)
    {
      return (NULL);
    }
  cnew = (char *) malloc (n + 1);
  if (cnew == NULL)
    return (NULL);
  cnew[n] = '\0';
  return (char *) strncpy (cnew, s, n);
}

int
__b2c__memcmp (const void *__b2c__s1, const void *__b2c__s2)
{
  if (__b2c__s1 == NULL && __b2c__s2 == NULL)
    return (0);
  if (__b2c__s1 == NULL)
    {
      __b2c__s1 = (void *) EmptyString;
    }
  if (__b2c__s2 == NULL)
    {
      __b2c__s2 = (void *) EmptyString;
    }
  return (memcmp (__b2c__s1, __b2c__s2, sizeof (void *)));
}

int
__b2c__strcmp (const char *__b2c__s1, const char *__b2c__s2)
{
  if (__b2c__s1 == NULL && __b2c__s2 == NULL)
    return (0);
  if (__b2c__s1 == NULL)
    {
      __b2c__s1 = EmptyString;
    }
  if (__b2c__s2 == NULL)
    {
      __b2c__s2 = EmptyString;
    }
  return (strcmp (__b2c__s1, __b2c__s2));
}

int
__b2c__strcasecmp (const char *__b2c__s1, const char *__b2c__s2)
{
  if (__b2c__s1 == NULL && __b2c__s2 == NULL)
    {
      return (0);
    }
  if (__b2c__s1 == NULL)
    {
      return (-1);
    }
  if (__b2c__s2 == NULL)
    {
      return (1);
    }
  return (strcasecmp (__b2c__s1, __b2c__s2));
}

void *
__b2c_str_realloc (char *ptr, size_t size)
{
  if (ptr == NULL || __b2c__buf ((char *) ptr) <= size)
    {
      if ((long) ptr & 1)
	{
	  ptr =
	    (char *) realloc (ptr - __b2c__BUFOFFSET,
			      __b2c__BUFOFFSET + size * 2 + 1);
	}
      else
	{
	  ptr = (char *) realloc (ptr, __b2c__BUFOFFSET + size * 2 + 1);
	}
      *(uint32_t *) ((char *) ptr + 4) = size * 2 + 1;
      *(uint8_t *) ((char *) ptr + 8) = 0;
      __b2c__SETRANGE (ptr);
      ptr += __b2c__BUFOFFSET;
    }
  return (ptr);
}

char *
__b2c_Copy_String (char *x, char *y)
{
  long ylen;
  if (y == NULL)
    {
      __b2c__STRFREE (x);
      return (NULL);
    }
  else
    {
      ylen = __b2c__len (y);
    }
  x = (char *) __b2c_str_realloc (x, ylen);
  memmove (x, y, ylen);
  if ((uintptr_t) x & 1)
    {
      __b2c__SETLEN (x, ylen);
    }
  x[ylen] = '\0';
  return (x);
}

char *
__b2c_Assign_String (char **x, char *y)
{
  char *tmp;
  if (*x != NULL && y != NULL && ((uintptr_t) y & 1) && __b2c__INRANGE (y))
    {
      if (__b2c__IS_SBUF (y))
	{
	  tmp = *x;
	  *x = y;
	  __b2c__UNSETBIT (*x);
	  __b2c__sbuffer[__b2c__sbuffer_ptr] = __b2c__topstring (tmp);
	  __b2c__SETBIT (__b2c__sbuffer[__b2c__sbuffer_ptr]);
	  return (*x);
	}
    }
  return (__b2c_Copy_String (*x, y));
}

char *
__b2c__topstring (char *ptr)
{
  unsigned int len;
  if ((long) ptr & 1)
    {
      return (ptr);
    }
  len = (ptr == NULL ? 0 : strlen (ptr));
  ptr = (char *) realloc (ptr, __b2c__BUFOFFSET + len + 1);
  memset (ptr + len, 0, __b2c__BUFOFFSET + 1);
  memmove (ptr + __b2c__BUFOFFSET, ptr, len + 1);
  *(uint32_t *) (ptr) = len;
  *(uint32_t *) (ptr + 4) = len + 1;
  __b2c__SETRANGE (ptr);
  return (ptr + __b2c__BUFOFFSET);
}

unsigned long
__b2c__len (const char *ptr)
{
  if (ptr == NULL)
    {
      return (0);
    }
  if (((uintptr_t) ptr & 1) && __b2c__INRANGE (ptr) && __b2c__VALID (ptr))
    {
      return (*(uint32_t *) (ptr - __b2c__BUFOFFSET));
    }
  return ((unsigned long) strlen (ptr));
}

static inline unsigned long
__b2c__buf (const char *ptr)
{
  if (ptr == NULL)
    {
      return (0);
    }
  if (((uintptr_t) ptr & 1) && __b2c__INRANGE (ptr))
    {
      return (*(uint32_t *) (ptr - __b2c__BUFOFFSET + 4));
    }
  return ((unsigned long) strlen (ptr) + 1);
}

char *
__b2c__loop_helper (jmp_buf buf)
{
  if (__b2c__loop_result__b2c__string_var != NULL)
    {
      __b2c__SETLEN (__b2c__loop_result__b2c__string_var, 0);
      __b2c__loop_result__b2c__string_var =
	__b2c_Assign_String (&__b2c__loop_result__b2c__string_var,
			     EmptyString);
    }
  longjmp (buf, 1);
  return (NULL);
}

long
__b2c__loop_helper2 (jmp_buf buf)
{
  __b2c__loop_result = 0;
  longjmp (buf, 1);
  return (0);
}

void
__b2c__catch_signal (int sig)
{
  switch (sig)
    {
    case SIGABRT:
      fprintf (stderr,
	       "ERROR: signal ABORT received - internal error. Try to compile the program with TRAP LOCAL to find the cause.\n");
      break;
    case SIGFPE:
      fprintf (stderr,
	       "ERROR: signal for FPE received - division by zero? Examine the calculations in the program.\n");
      break;
    case SIGSEGV:
      fprintf (stderr,
	       "ERROR: signal for SEGMENTATION FAULT received - memory invalid or array out of bounds? Try to compile the program with TRAP LOCAL to find the cause.\n");
      break;
    case SIGILL:
      fprintf (stderr,
	       "ERROR: signal for ILLEGAL INSTRUCTION received - executing the program on other hardware? Try to recompile the program from scratch.\n");
      break;
    }
  exit (sig);
}

void
__b2c__segv (int sig)
{
  longjmp (__b2c__jump, 1);
}

int
__b2c__memory__check (volatile char *x, int size)
{
  int i, illegal = 0;
  void (*handler) (int);
  handler = signal (SIGSEGV, __b2c__segv);
  if (!setjmp (__b2c__jump))
    {
      for (i = 0; i < size; i++)
	if (*(x + i))
	  continue;
    }
  else
    illegal = 1;
  if (__b2c__trap)
    signal (SIGSEGV, __b2c__catch_signal);
  else
    signal (SIGSEGV, handler);
  return (illegal);
}

char *
__b2c__min_str (char *x, char *y)
{
  if (strcmp (x, y) < 0)
    {
      return (x);
    }
  return (y);
}

char *
__b2c__max_str (char *x, char *y)
{
  if (strcmp (x, y) > 0)
    {
      return (x);
    }
  return (y);
}

char *
__b2c__str (double nr)
{
  long idx;
  int len;
  idx = __sbuf_malloc_handle (32);
  if (floor (nr) == nr)
    {
      len = snprintf (__b2c__sbuffer[idx], 32, "%ld", (long) nr);
    }
  else
    {
      len = snprintf (__b2c__sbuffer[idx], 32, "%g", (double) nr);
    } __b2c__SETLEN (__b2c__sbuffer[idx], len);
  __b2c__sbuffer[idx][len] = '\0';
  return (char *) (__b2c__sbuffer[idx]);
}

long
__b2c__delim_engine (int type, long *returned_value, char *string,
		     char *delim, long nr)
{
  long x, len, cnt = 0, start = 0;
  int in_string = 0, is_escaped = 0;
  if (delim == NULL)
    {
      delim = __b2c__option_delim;
    }
  len = __b2c__len (delim);
  for (x = 0; string != NULL && string[x] != 0; x++)
    {
      if (!in_string)
	{
	  if (string[x] == delim[0])
	    {
	      if (!strncmp (string + x, delim, len))
		{
		  if (__b2c__collapse == 0)
		    {
		      cnt++;
		    }
		  else if (x + len - start > len)
		    {
		      cnt++;
		    }
		  if (nr && nr == cnt)
		    {
		      break;
		    }
		  else
		    {
		      start = x + len;
		    }
		}
	    }
	}
      if (string[x] == 92)
	{
	  if (!is_escaped)
	    {
	      is_escaped = 1;
	    }
	  else
	    {
	      is_escaped = 0;
	    }
	}
      else if (string[x] == __b2c__option_dq)
	{
	  if (!is_escaped && __b2c__option_quoted)
	    {
	      in_string = 1 - in_string;
	    }
	  is_escaped = 0;
	}
      else
	{
	  is_escaped = 0;
	}
    }
  switch (type)
    {
    case 1:
      if (nr - cnt > 1)
	{
	  *returned_value = 0;
	}
      else
	{
	  *returned_value = x - start;
	}
      break;
    case 2:
      if (x == 0)
	{
	  *returned_value = 0;
	}
      else
	{
	  if (__b2c__collapse == 0)
	    {
	      cnt++;
	    }
	  else if (x + len - start > len)
	    {
	      cnt++;
	    }
	  *returned_value = cnt;
	}
      break;
    default:
      *returned_value = 0;
    }
  return (start);
}

int
__b2c_utf8_conv (int txt, char *utf8)
{
  unsigned char b1, b2, b3;
  int len;
  if (txt > 0xFFFF)
    {
      b1 = txt & 0x0000FF;
      b2 = (txt & 0x00FF00) >> 8;
      b3 = (txt & 0xFF0000) >> 16;
      len =
	snprintf (utf8, 5, "%c%c%c%c", 0xF0 | (b3 >> 2),
		  0x80 | ((b3 & 0x03) << 4) | ((b2 & 0xF0) >> 4),
		  0x80 | ((b2 & 0x0F) << 2) | ((b1 & 0xC0) >> 6),
		  0x80 | (b1 & 0x3F));
    }
  else if (txt > 0x07FF)
    {
      b1 = txt & 0x00FF;
      b2 = (txt & 0xFF00) >> 8;
      len = snprintf (utf8, 4, "%c%c%c", 0xE0 | ((b2 & 0xF0) >> 4),
		      0x80 | ((b2 & 0x0F) << 2) | ((b1 & 0xC0) >> 6),
		      0x80 | (b1 & 0x3F));
    }
  else if (txt > 0x007F)
    {
      b1 = txt & 0x00FF;
      b2 = (txt & 0xFF00) >> 8;
      len = snprintf (utf8, 3, "%c%c",
		      0xC0 | (b2 << 2) | ((b1 & 0xC0) >> 6),
		      0x80 | (b1 & 0x3F));
    }
  else
    {
      len = snprintf (utf8, 2, "%c", txt & 0x7F);
    }
  return (len);
}

unsigned long
__b2c__ulen (int l, char *k, char *func, ...)
{
  int pos;
  long len = 0;
  char *ptr;
  va_list ap;
  va_start (ap, func);
  ptr = va_arg (ap, char *);
  pos = va_arg (ap, int);
  va_end (ap);
  if (ptr == NULL)
    {
      return (0);
    }
  if (pos < 0)
    {
      while (*ptr)
	{
	  if ((*ptr & 0xF0) == 0xF0)
	    {
	      len++;
	      ptr += 4;
	    }
	  else if ((*ptr & 0xE0) == 0xE0)
	    {
	      len++;
	      ptr += 3;
	    }
	  else if ((*ptr & 0xC0) == 0xC0)
	    {
	      len++;
	      ptr += 2;
	    }
	  else if ((*ptr & 0x80) == 0)
	    {
	      len++;
	      ptr++;
	    }
	  else
	    {
	      ERROR = 38;
	      RUNTIMEFERR (func, ERROR, k, l);
	    }
	}
    }
  else
    {
      len = __b2c__ucs2_clen (l, k, "ULEN", ptr, pos);
    }
  return (len);
}

unsigned long
__b2c__blen (int l, char *k, char *func, char *ptr, long c, ...)
{
  va_list ap;
  char *org = ptr;
  int flag;
  if (ptr == NULL)
    {
      return (0);
    }
  va_start (ap, c);
  flag = va_arg (ap, int);
  va_end (ap);
  if (flag)
    {
      c = __b2c__ulen (l, k, "BYTELEN", org, -1) - c;
    }
  while (*ptr && c > 0)
    {
      if ((*ptr & 0xF0) == 0xF0)
	{
	  ptr += 4;
	}
      else if ((*ptr & 0xE0) == 0xE0)
	{
	  ptr += 3;
	}
      else if ((*ptr & 0xC0) == 0xC0)
	{
	  ptr += 2;
	}
      else if ((*ptr & 0x80) == 0)
	{
	  ptr++;
	}
      else
	{
	  ERROR = 38;
	  fprintf (stderr, "Cannot decode UTF-8 string: '%s'\n", org);
	  RUNTIMEFERR (func, ERROR, k, l);
	}
      c--;
    }
  if (flag)
    {
      return (__b2c__len (org) - (ptr - org));
    }
  else
    {
      return (ptr - org);
    }
}

unsigned long
__b2c__ucs2_clen (int l, char *k, char *func, char *ptr, int c)
{
  int len = 0;
  char *org;
  if (ptr == NULL)
    return (0);
  org = ptr;
  while (*ptr && c > 0)
    {
      if ((*ptr & 0xF0) == 0xF0)
	{
	  ptr += 4;
	  c -= 4;
	}
      else if ((*ptr & 0xE0) == 0xE0)
	{
	  ptr += 3;
	  c -= 3;
	}
      else if ((*ptr & 0xC0) == 0xC0)
	{
	  ptr += 2;
	  c -= 2;
	}
      else if ((*ptr & 0x80) == 0)
	{
	  ptr++;
	  c--;
	}
      else
	{
	  ERROR = 38;
	  fprintf (stderr, "Cannot decode UTF-8 string: '%s'\n", org);
	  RUNTIMEFERR (func, ERROR, k, l);
	}
      len++;
    }
  return (len);
}
